import "./style.css";
import { reactive as w, ref as N, watchEffect as P, onActivated as D, nextTick as j, resolveComponent as f, createElementBlock as x, openBlock as F, createElementVNode as l, createVNode as v, withCtx as T, withDirectives as V, vShow as W, onBeforeUnmount as A } from "vue";
import { Button as J } from "@opentiny/vue";
import { LinkButton as O, CloseIcon as U, VueMonaco as H } from "@opentiny/tiny-engine-common";
import { useCanvas as g, useNotify as M, useModal as y, useHelp as I } from "@opentiny/tiny-engine-meta-register";
import { initCompletion as z } from "@opentiny/tiny-engine-common/js/completion";
import { lint as R, initLinter as Y } from "@opentiny/tiny-engine-common/js/linter";
import { insertName as q, string2Ast as b, formatString as G, ast2String as K } from "@opentiny/tiny-engine-common/js/ast";
import { constants as Q } from "@opentiny/tiny-engine-utils";
import { isFunction as X } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: k } = Q, r = w({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null,
  // 记录当前是否已经有弹窗，防止使用 ctrl + s 的时候重复弹窗
  hasErrorPopup: !1
}), a = N(null);
let _ = null;
const S = () => {
  var t, n;
  const o = ((n = (t = g()).getSchema) == null ? void 0 : n.call(t)) || {};
  return o.methods = (o == null ? void 0 : o.methods) || {}, o.methods;
}, Z = () => g().pageState.pageSchema && Object.keys(S()) || [], E = () => {
  const t = Object.entries(S()).map(([n, e]) => q(n, e.value)).join(`
`);
  try {
    _ = b(t);
  } catch (n) {
    M({
      type: "error",
      message: `代码静态检查有错误：${n}`
    });
  }
  return t;
}, $ = (o) => {
  if (r.isChanged = o !== r.script, !a.value)
    return;
  const t = a.value.getEditor().getModel();
  R(t, r.linterWorker);
}, ee = ({ name: o, content: t }) => {
  if (!o)
    return;
  const n = S(), e = {
    type: k.JSFunction,
    value: t
  };
  g().updateSchema({ methods: { ...n, [o]: e } });
}, B = () => {
  const { message: o } = y();
  if (!r.isChanged || r.hasErrorPopup)
    return !1;
  if (r.hasError)
    return r.hasErrorPopup = !0, o({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存",
      exec: () => {
        r.hasErrorPopup = !1;
      }
    }), !1;
  const t = a.value.getEditor().getValue(), n = b(t), e = {};
  return n.program.body.forEach((s, i) => {
    var u, m;
    const d = (u = s == null ? void 0 : s.id) == null ? void 0 : u.name;
    (m = n.program.body[i + 1]) != null && m.leadingComments && s.trailingComments === n.program.body[i + 1].leadingComments && delete s.trailingComments;
    const p = G(K(s).trim(), "javascript");
    d && (e[d] = {
      type: k.JSFunction,
      value: p
    });
  }), g().updateSchema({ methods: e }), g().setSaved(!1), r.isChanged = !1, M({
    type: "success",
    message: "保存成功！"
  }), !0;
}, te = (o) => (t) => {
  const { confirm: n } = y(), e = X(t) ? t : () => o("close");
  if (!r.isChanged) {
    e(!0);
    return;
  }
  n({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      e(B());
    },
    cancel() {
      e(!0);
    }
  });
}, oe = () => {
  if (!r.editorSelection || !a.value)
    return;
  const o = a.value.getEditor();
  o.setSelection(r.editorSelection), o.focus();
  const t = o.getTopForLineNumber(r.editorSelection.startLineNumber - 1);
  o.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: t
    },
    0
  );
}, ne = (o) => {
  var e;
  if (!o)
    return;
  const t = _ == null ? void 0 : _.program.body.filter((s) => {
    var i;
    return o === ((i = s == null ? void 0 : s.id) == null ? void 0 : i.name);
  });
  if (t.length === 0)
    return;
  const n = (e = t[0]) == null ? void 0 : e.loc;
  n && (r.editorSelection = {
    startColumn: n.start.column,
    startLineNumber: n.start.line,
    endColumn: n.end.column + 1,
    endLineNumber: n.end.line
  }), r.editorSelection && oe();
}, se = ({ emit: o }) => (P(() => {
  r.script = E();
}), D(() => {
  j(() => {
    var t;
    r.script = E(), (t = a.value) == null || t.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: r,
  monaco: a,
  change: $,
  saveMethods: B,
  close: te(o)
}), re = (o, t) => {
  const n = o.__vccOpts || o;
  for (const [e, s] of t)
    n[e] = s;
  return n;
}, ie = {
  saveMethod: ee,
  highlightMethod: ne,
  getMethodNameList: Z,
  getMethods: S
}, ce = {
  components: {
    MonacoEditor: H,
    TinyButton: J,
    CloseIcon: U,
    LinkButton: O
  },
  emits: ["close"],
  setup(o, { emit: t }) {
    const n = I().getDocsUrl("script"), { state: e, monaco: s, change: i, close: d, saveMethods: p } = se({ emit: t }), u = {
      language: "javascript",
      minimap: {
        enabled: !1
      },
      placeholder: `// ✅ 函数声明可以保存
       function topLevelFunction(){ 
      ​ ​ const message = 'hello tiny-engine.' 
      ​ ​ console.log(message) 
      } 
 
      // ❌ 顶层/常规 变量声明 
 const someVariable = 42 
      // ❌ 表达式 
 const result = someVariable + 10`,
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, m = (h) => {
      var c;
      s.value && (e.completionProvider = z(s.value.getMonaco(), (c = s.value.getEditor()) == null ? void 0 : c.getModel()), e.linterWorker = Y(h, s.value.getMonaco(), e));
    };
    return A(() => {
      var h, c, C;
      (h = e.completionProvider) == null || h.forEach((L) => {
        L.dispose();
      }), (C = (c = e.linterWorker) == null ? void 0 : c.terminate) == null || C.call(c);
    }), {
      state: e,
      monaco: s,
      options: u,
      close: d,
      change: i,
      saveMethods: p,
      editorDidMount: m,
      docsUrl: n
    };
  }
}, le = { class: "plugin-page-js-container" }, ae = { class: "code-edit-head" }, de = { class: "head-left" }, ue = { class: "head-right" }, me = { class: "dots" }, pe = { class: "code-edit-content" };
function ge(o, t, n, e, s, i) {
  const d = f("link-button"), p = f("tiny-button"), u = f("close-icon"), m = f("monaco-editor");
  return F(), x("div", le, [
    l("div", ae, [
      l("div", de, [
        t[0] || (t[0] = l("span", { class: "title" }, "页面 JS", -1)),
        v(d, { href: e.docsUrl }, null, 8, ["href"])
      ]),
      l("div", ue, [
        v(p, {
          type: "primary",
          class: "save-btn",
          onClick: e.saveMethods
        }, {
          default: T(() => [
            t[1] || (t[1] = l("span", null, "保存", -1)),
            V(l("span", me, null, 512), [
              [W, e.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        v(u, { onClose: e.close }, null, 8, ["onClose"])
      ])
    ]),
    l("div", pe, [
      v(m, {
        ref: "monaco",
        value: e.state.script,
        options: e.options,
        onChange: e.change,
        onEditorDidMount: e.editorDidMount,
        onShortcutSave: e.saveMethods
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount", "onShortcutSave"])
    ])
  ]);
}
const he = /* @__PURE__ */ re(ce, [["render", ge], ["__scopeId", "data-v-a6c97b37"]]), fe = {
  id: "engine.plugins.pagecontroller",
  title: "页面 JS",
  type: "plugins",
  icon: "plugin-icon-js",
  align: "top",
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
}, Le = {
  ...fe,
  apis: ie,
  entry: he
};
export {
  Le as default
};
